love.graphics.setBackgroundColor(1, 1, 1)
local Width = 800
local Height = 600
maps = {{},{},{},{},{}}
explanation = {items = {}, skills = {}}
editor = {}
fontSize = {}
images = {}
menu = 1
menuButtons = {}
for i = 1, 100 do
  fontSize[i] = love.graphics.newFont(i)
end
require("T")
require("map")
require("explanation")
require("editor")
local player = {x = 1, y = 1, HP = 100, maxHP = 100, MP = 100, maxMP = 100, attack = 4, defence = 0, EXP = 0, money = 0, skillPoint = 0, level = 1, unitX = 0, unitY = 0, dir = "", dirPrev = "", lastDir = "down", doing = "", diamonds = 0, keys = 0, package = 0, shop = 0, skillWindow = 0, slot = {position = 1,{},{},{},{},{},{}}, items = {}, levels = {0,5,10,20,30,50,70,100}, equipment = {}}
local map
local animations = {}
local sounds = {length = 2}
local music = {length = 1, timer = 227}
local mouse = {x = 0, y = 0}
local shop = {
  {model=1,cost=30},{model=2,cost=50},{model=3,cost=80},{model=35,cost=18},{model=36,cost=30},{model=37,cost=48},{model=5,cost=40},{model=8,cost=64},{model=26,cost=90},{model=23,cost=80},{model=28,cost=85},{model=30,cost=55},{model=34,cost=55}
  
}
player.skills = {
  {level=1,top=1,cost=1,image=1},{level=1,top=1,cost=1,image=2},{level=1,top=1,cost=2,image=3},{level=1,top=1,cost=3,image=4},{level=0,top=3,cost=2,image=5,MP=8},{level=0,top=3,cost=2,image=6,MP=12}
}
local bullets = {}
images = {ground = {length = 4}, item = {length = 9}, player = {length = 3}, monster = {length = 9}, thing = {length = 47}, bullet = {length = 3}, editorItem = {length = 1}, skill = {{length=1},{length=1},{length=1},{length=1},{length=3},{length=3}}}
for i = 1, #shop do
  shop[i].x = (i-1)%8
  shop[i].y = math.floor((i-1)/8)
  function draw(self)
    love.graphics.setColor(1, 1, 1)
    love.graphics.draw(images.thing[self.model], self.x*57 + 337, self.y*57 + 112, 0, 1.45)
    love.graphics.setFont(fontSize[25])
    love.graphics.setColor(1, 0.95, 0.1)
    love.graphics.printf(self.cost, self.x*57 + 320, self.y*57 + 140, 82, "center")
  end
  function clicked(self, x, y, button)
    if player.shop > 0 and isInside(self.x*57 + 337, self.y*57 + 112, 45, 45, x, y) and player.money >= self.cost and player.doing ~= "fighting" then
      if button == 1 then
        player.money = player.money - self.cost
        newAnimation("cost money", 330, 60, self.cost, 35, 0)
        getItem(self.model)
      end
    end
  end
  shop[i].draw = draw
  shop[i].clicked = clicked
end
for i = 1, #player.skills do
  player.skills[i].originCost = player.skills[i].cost
  player.skills[i].x = (i-1)%8
  player.skills[i].y = math.floor((i-1)/8)
  player.skills[i].Type = "skill"
  function draw(self)
    love.graphics.setColor(1, 1, 1)
    local l = self.level
    if l <= 0 then l = 1 end
    love.graphics.draw(images.skill[self.image][l], self.x*57 + 321, self.y*57 + 214, 0, 1.46)
    love.graphics.setFont(fontSize[25])
    if self.level == 0 then
      love.graphics.setColor(0, 0, 0, 0.7)
      love.graphics.rectangle("fill", self.x*57 + 321, self.y*57 + 214, 46, 46)
    end
    if self.top <= 1 or self.level < self.top then
      love.graphics.setColor(1, 0.95, 0.1)
      love.graphics.printf(self.cost, self.x*57 + 304, self.y*57 + 242, 82, "center")
    end
    if self.dragged then
      love.graphics.setColor(1, 1, 1)
      love.graphics.draw(images.skill[self.image][l], self.mouseX, self.mouseY, 0, 1.46)
    end
  end
  function clicked(self, x, y, button)
    if player.skillWindow > 0 and isInside(self.x*57 + 321, self.y*57 + 214, 46, 46, x, y) then
      if button == 1 and player.skillPoint >= self.cost then
        love.audio.play(sounds[1])
        player.skillPoint = player.skillPoint - self.cost
        if self.level < self.top then self.level = self.level + 1 end
        if self.image == 1 then
          player.maxHP = player.maxHP + 20
          player.HP = player.HP + 20
        elseif self.image == 2 then
          player.maxMP = player.maxMP + 25
          player.MP = player.MP + 25
        elseif self.image == 3 then
          player.attack = player.attack + 1
        elseif self.image == 4 then
          player.defence = player.defence + 1
        elseif self.image == 5 then
          self.cost = 3
        elseif self.image == 6 then
          self.cost = 3
        end
      elseif button == 2 and self.image >= 5 and self.level > 0 then
        local l = self.level
        if l <= 0 then l = 1 end
        drag = {item = self, image = images.skill[self.image][l], x = x, y = y, imageSize = 1.46}
      end
    end
  end
  player.skills[i].draw = draw
  player.skills[i].clicked = clicked
end
function love.load()
  images.blackness = love.graphics.newImage("blackness.png")
  images.package = love.graphics.newImage("package.png")
  images.pack = love.graphics.newImage("pack.png")
  images.attack = love.graphics.newImage("attack.png")
  images.money = love.graphics.newImage("money.png")
  images.star = love.graphics.newImage("star.png")
  images.daggerL = love.graphics.newImage("daggerL.png")
  images.daggerR = love.graphics.newImage("daggerR.png")
  images.defence = love.graphics.newImage("defence.png")
  images.window = love.graphics.newImage("window.png")
  images.skillPoint = love.graphics.newImage("skillPoint.png")
  for i = 1, images.ground.length do
    images.ground[i] = love.graphics.newImage("ground/ground" .. i .. ".png")
  end
  for i = 1, images.item.length do
    images.item[i] = love.graphics.newImage("item/item" .. i .. ".png")
  end
  for i = 1, images.player.length do
    images.player[i] = {}
    images.player[i].left = love.graphics.newImage("player/player" .. i .. "-left.png")
    images.player[i].right = love.graphics.newImage("player/player" .. i .. "-right.png")
    images.player[i].up = love.graphics.newImage("player/player" .. i .. "-up.png")
    images.player[i].down = love.graphics.newImage("player/player" .. i .. "-down.png")
  end
  for i = 1, images.monster.length do
    images.monster[i] = love.graphics.newImage("monster/monster" .. i .. ".png")
  end
  for i = 1, images.thing.length do
    images.thing[i] = love.graphics.newImage("thing/thing" .. i .. ".png")
  end
  for i = 1, images.editorItem.length do
    images.editorItem[i] = love.graphics.newImage("editorItems/editorItem" .. i .. ".png")
  end
  for i = 1, images.bullet.length do
    images.bullet[i] = {}
    images.bullet[i].left = love.graphics.newImage("bullet/bullet" .. i .. "-left.png")
    images.bullet[i].right = love.graphics.newImage("bullet/bullet" .. i .. "-right.png")
    images.bullet[i].up = love.graphics.newImage("bullet/bullet" .. i .. "-up.png")
    images.bullet[i].down = love.graphics.newImage("bullet/bullet" .. i .. "-down.png")
  end
  for i = 1, #images.skill do
    for j = 1, images.skill[i].length do
      images.skill[i][j] = love.graphics.newImage("skill/skill" .. i .. "-" .. j .. ".png")
    end
  end
  for i = 1, sounds.length do
    sounds[i] = love.audio.newSource("sound/sound" .. i .. ".mp3", "stream")
  end
  for i = 1, music.length do
    music[i] = love.audio.newSource("music/music" .. i .. ".mp3", "stream")
  end
end
newMenuButton(50, 50, 700, 100, 1, "Maps", {2})
newMenuButton(50, 50, 100, 100, 2, 1, {0, 1})
newMenuButton(50, 200, 700, 100, 1, "Self-edited Maps", {3})
newMenuButton(50, 450, 700, 100, 1, "Editor", {-1})
newMenuButton(50, 450, 700, 100, -1, "Next", {-2})
function love.draw()
  if menu == 0 then
    love.graphics.setColor(0.2, 0.5, 0.2)
    love.graphics.rectangle("fill", 0, 0, 800, 600)
    for y = player.y - 7, player.y + 7 do
      for x = player.x - 10, player.x + 10 do
        local grid = {map[1][map.width*y+x+1], map[2][map.width*y+x+1]}
        if grid[1] ~= nil and x >= 0 and x < map.width then
          local screenY = (y-(player.y-7))*40 - player.unitY
          local screenX = (x-(player.x-10))*40 - player.unitX
          love.graphics.setColor(1, 1, 1)
          if map[1][map.width*y+x+1] >= 1 then
            love.graphics.draw(images.ground[map[1][map.width*y+x+1]], screenX, screenY, 0, 0.63)
          end
          if map[2][map.width*y+x+1] >= 1 then
            love.graphics.draw(images.item[map[2][map.width*y+x+1]], screenX, screenY, 0, 0.63)
          end
        end
      end
    end
    love.graphics.setColor(1, 1 ,1)
    local haveSword = player.equipment[1] ~= nil
    local playerImage = 1
    if player.equipment[4] ~= nil and player.equipment[4].image ~= nil then
      playerImage = player.equipment[4].image
    end
    if player.lastDir == "up" then
      if haveSword then love.graphics.draw(images.daggerR, 416, 291, 0, 1) end
      love.graphics.draw(images.player[playerImage].up, 400-1, 280, 0, 0.65)
    elseif player.lastDir == "down" then
      love.graphics.draw(images.player[playerImage].down, 400-1, 280, 0, 0.65)
      if haveSword then love.graphics.draw(images.daggerL, 394, 290, 0, 1) end
    elseif player.lastDir == "left" then
      if haveSword then love.graphics.draw(images.daggerL, 398, 292, 0, 1) end
      love.graphics.draw(images.player[playerImage].left, 400-1, 280, 0, 0.65)
    elseif player.lastDir == "right" then
      if haveSword then love.graphics.draw(images.daggerR, 410, 292, 0, 1) end
      love.graphics.draw(images.player[playerImage].right, 400-1, 280, 0, 0.65)
    end
    bullets:draw()
    for y = player.y - 7, player.y + 7 do
      for x = player.x - 10, player.x + 10 do
        local grid = {map[1][map.width*y+x+1], map[2][map.width*y+x+1]}
        if grid[1] ~= nil and x >= 0 and x < map.width then
          local screenY = (y-(player.y-7))*40 - player.unitY
          local screenX = (x-(player.x-10))*40 - player.unitX
          love.graphics.setColor(1, 1, 1)
          for i = 1, #map.monsters do
            local monster = map.monsters[i]
            if monster.x == x and monster.y == y then
              love.graphics.setColor(1, 1, 1)
              love.graphics.draw(images.monster[monster.model] ,screenX, screenY, 0, 0.63)
              love.graphics.setColor(1, 0, 0)
              love.graphics.rectangle("fill", screenX, screenY - 5, 39, 10)
              love.graphics.setColor(0, 1, 0)
              love.graphics.rectangle("fill", screenX, screenY - 5, 39*monster.HP/monster.maxHP, 10)
              love.graphics.setColor(0, 0, 0)
              love.graphics.rectangle("line", screenX, screenY - 5, 39, 10)
              love.graphics.setFont(fontSize[10])
              love.graphics.printf(monster.HP, screenX, screenY - 6, 39, "center")
              if monster.attack > 0 then
                love.graphics.setColor(1, 1, 0)
                love.graphics.printf(monster.attack, screenX, screenY + 36, 36, "right")
              end
            end
          end
        end
      end
    end
    love.graphics.setColor(1, 1, 1)
    love.graphics.draw(images.blackness, -100, -200, 0, 2)
    love.graphics.setColor(1, 1, 1)
    love.graphics.draw(images.item[1], 50, 200, 0, 0.8)
    love.graphics.setFont(fontSize[30])
    love.graphics.print(":" .. player.diamonds .. "/" .. map.goals, 105, 205)
    love.graphics.setColor(1, 0, 0)
    love.graphics.rectangle("fill", 10, 10, 200, 30)
    love.graphics.setColor(0, 1, 0)
    love.graphics.rectangle("fill", 10, 10, 200*player.HP/player.maxHP, 30)
    love.graphics.setColor(1, 1, 1)
    love.graphics.rectangle("line", 10, 10, 200, 30)
    love.graphics.setColor(0, 0, 0)
    love.graphics.setFont(fontSize[25])
    love.graphics.printf(player.HP.."/"..player.maxHP, 10, 10, 200, "center")
    love.graphics.setColor(1, 1, 1)
    love.graphics.rectangle("fill", 10, 50, 200, 30)
    love.graphics.setColor(0.24, 0.61, 0.95)
    love.graphics.rectangle("fill", 10, 50, 200*player.MP/player.maxMP, 30)
    love.graphics.setColor(1, 1, 1)
    love.graphics.rectangle("line", 10, 50, 200, 30)
    love.graphics.setColor(0, 0, 0)
    love.graphics.setFont(fontSize[25])
    love.graphics.printf(player.MP.."/"..player.maxMP, 10, 50, 200, "center")
    love.graphics.setColor(1, 1, 1)
    love.graphics.rectangle("fill", 10, 90, 200, 30)
    love.graphics.setColor(0.71, 0.32, 0.77)
    if player.level < #player.levels then
      love.graphics.rectangle("fill", 10, 90, 200*player.EXP/player.levels[player.level+1], 30)
    else
      love.graphics.rectangle("fill", 10, 90, 200, 30)
    end
    love.graphics.setColor(1, 1, 1)
    love.graphics.rectangle("line", 10, 90, 200, 30)
    love.graphics.setColor(0, 0, 0)
    love.graphics.setFont(fontSize[25])
    if player.level < #player.levels then
      love.graphics.printf(player.EXP.."/"..player.levels[player.level+1], 10, 90, 200, "center")
    else
      love.graphics.printf("MAX", 10, 90, 200, "center")
    end
    love.graphics.setColor(1, 1, 1)
    love.graphics.draw(images.star, 175, 82, 0, 1.3)
    love.graphics.setColor(0, 0, 0)
    love.graphics.printf(player.level, 150, 90, 90, "center")
    love.graphics.setColor(1, 1, 1)
    love.graphics.draw(images.attack, 220, 10, 0, 0.6)
    love.graphics.setFont(fontSize[35])
    if player.equipment[1] == nil then
      love.graphics.print(player.attack, 260, 10)
    else
      love.graphics.setColor(0, 1, 0)
      love.graphics.print(player.attack + player.equipment[1].attack, 260, 10)
    end
    love.graphics.setColor(1, 1, 1)
    love.graphics.draw(images.defence, 213, 40, 0, 0.8)
    if player.equipment[3] ~= nil or player.equipment[4] ~= nil or player.equipment[5] ~= nil or player.equipment[6] ~= nil then
      love.graphics.setColor(0, 1, 0)
    end
    love.graphics.print(player.defence, 260, 50)
    love.graphics.setColor(1, 1, 1)
    love.graphics.draw(images.money, 28, 122, 0, 0.8)
    love.graphics.setColor(1, 0.95, 0.1)
    love.graphics.print(player.money, 75, 132)
    love.graphics.setColor(1, 1, 1)
    love.graphics.setFont(fontSize[30])
    love.graphics.print("x-"..player.x..", y-"..player.y, 10, 560)
    for i = 0, 5 do
      love.graphics.setColor(1, 1, 1)
      local x = 230 + i*57
      local y = 535
      love.graphics.draw(images.pack, x, y, 0, 1.45)
      if player.slot.position == 1 and player.equipment[i + 1] ~= nil then
        local equip = player.equipment[i + 1]
        love.graphics.setColor(1, 1, 1)
        love.graphics.draw(images.thing[equip.model], x, y, 0, 1.65)
        love.graphics.rectangle("fill", x, y + 55, 53, 10)
        love.graphics.setColor(1, 0.95, 0.1)
        love.graphics.rectangle("fill", x, y + 55, 53*equip.durability[1]/equip.durability[2], 10)
        love.graphics.setColor(1, 1, 1)
        love.graphics.rectangle("line", x, y + 55, 53, 10)
        love.graphics.setColor(0, 0, 0)
        love.graphics.setFont(fontSize[10])
        love.graphics.printf(equip.durability[1], x, y + 53, 53, "center")
      else
        local item = player.slot[player.slot.position][i + 1]
        if item ~= nil then
          local l = item.skill.level
          if l <= 0 then l = 1 end
          love.graphics.setColor(1, 1, 1)
          love.graphics.draw(images.skill[item.skill.image][l], x, y, 0, 1.65)
          love.graphics.setColor(0.34, 0.51, 1)
          love.graphics.setFont(fontSize[25])
          love.graphics.printf(item.skill.MP, x, y + 40, 53, "center")
        end
      end
    end
    if map.keys > 0 then
      love.graphics.setColor(1, 1, 1)
      love.graphics.draw(images.item[2], 65, 250, 0, 0.63)
      love.graphics.setFont(fontSize[30])
      love.graphics.print(": " .. player.keys, 105, 255)
    end
    playAnimation()
    if player.package > 0 then
      love.graphics.setColor(1, 1, 1)
      love.graphics.draw(images.package, 320, 350, 0, 1.5)
      for i = 1, 100 do
        if player.items[i] ~= nil then
          player.items[i]:draw()
        end
      end
      for i = 1, 100 do
        if player.items[i] ~= nil then
          player.items[i]:draw2()
        end
      end
    end
    if player.shop > 0 then
      love.graphics.setColor(1, 1, 1)
      love.graphics.draw(images.package, 320, 95, 0, 1.5)
      for i = 1, 100 do
        if shop[i] ~= nil then
          shop[i]:draw()
        end
      end
    end
    if player.skillWindow > 0 then
      love.graphics.setColor(1, 1, 1)
      love.graphics.draw(images.window, 290, 160, 0, 1.5)
      love.graphics.draw(images.skillPoint, 320, 165, 0, 1)
      love.graphics.setFont(fontSize[30])
      love.graphics.print(player.skillPoint, 360, 165)
      for i = 1, 100 do
        if player.skills[i] ~= nil then
          player.skills[i]:draw()
        end
      end
    end
  else
    for i = 1, #menuButtons do
      menuButtons[i]:draw()
    end
    if menu == -1 then
      editor.initMenu:draw()
    elseif menu == -2 then
      editor:draw()
    end
  end
  if drag ~= nil then
    love.graphics.setColor(1, 1, 1)
    love.graphics.draw(drag.image, drag.x, drag.y, 0, drag.imageSize)
  end
end
function love.update(dt)
  if menu == 0 then
    music.timer = music.timer + dt
    if music.timer > 228 then
      music.timer = 0
      love.audio.play(music[1])
    end
    bullets:update()
    if player.dirPrev ~= "" then
      player.move(player.dirPrev, dt)
    end
    for i = 1, #animations do
      animations[i].timer = animations[i].timer + dt
      animations[i].delay = animations[i].delay - dt
    end
  elseif menu == -1 then
    editor.initMenu:update(dt)
  elseif menu == -2 then
    editor:update(dt)
  end
end
function love.mousepressed(x, y, button)
  local dragging = drag ~= nil
  if menu == -1 then
    editor.initMenu:mousepressed(x, y, button)
  end
  for i = 1, #menuButtons do
    if menuButtons[i]:clicked(x, y) then return end
  end
  if menu == 0 then
    if player.package >= 1 then
      if isInside(780, 350, 20, 250, x, y) then
        player.package = player.package + 1
      elseif isInside(320, 350, 20, 250, x, y) and player.package > 1 then
        player.package = player.package - 1
      end
    end
    for i = 1, 100 do
      if player.items[i] ~= nil then
        player.items[i]:clicked(x, y, button)
      end
    end
    for i = 1, 100 do
      if player.skills[i] ~= nil then
        player.skills[i]:clicked(x, y, button)
      end
    end
    for i = 1, #shop do
      shop[i]:clicked(x, y, button)
    end
  elseif menu == -2 then
    editor:mousepressed(x, y, button)
  end
  for i = 0, 5 do
    local X = 230 + i*57
    local Y = 535
    if player.slot.position > 1 and drag ~= nil and drag.item.Type ~= nil and drag.item.Type == "skill" and isInside(X, Y, 46, 46, x, y) then
      player.slot[player.slot.position][i + 1] = {x = X, y = Y, skill = drag.item, position = i + 1, clicked = slotClicked}
    elseif player.slot.position > 1 and isInside(X, Y, 46, 46, x, y) and player.slot[player.slot.position][i + 1] ~= nil then
      player.slot[player.slot.position][i + 1]:clicked(x, y, button)
    end
  end
  if dragging and drag ~= nil and drag.keepDrag ~= true then drag = nil end
end
function love.mousereleased(x, y, button)
  if menu == 0 then
    
  elseif menu == -1 then
    editor.initMenu:mousereleased(x, y, button)
  elseif menu == -2 then
    editor:mousereleased(x, y, button)
  end
end
function love.mousemoved(x, y, dx, dy)
  mouse.x = x
  mouse.y = y
  if drag ~= nil then
    drag.x = x
    drag.y = y
  end
  if menu ~= 0 then return end
  if drag == nil then
    for i = 1, 100 do
      if player.items[i] ~= nil then
        player.items[i]:mouseCover(x, y, dx, dy)
      end
    end
  end
end
function love.keypressed(k)
  if k == "p" then clean() end
  if menu == 0 then
    if k == "a" then player.dir = "left"
    elseif k == "d" then player.dir = "right"
    elseif k == "w" then player.dir = "up"
    elseif k == "s" then player.dir = "down"
    end
    if k == "q" then
      if player.slot.position == 1 then
        player.slot.position = #player.slot
      else
        player.slot.position = player.slot.position - 1
      end
    elseif k == "e" then
      if player.slot.position == #player.slot then
        player.slot.position = 1
      else
        player.slot.position = player.slot.position + 1
      end
    end
    if k == "b" and player.skillWindow == 0 then
      if player.package == 0 then
        player.package = 1
      else
        player.package = 0
      end
    elseif k == "n" and player.skillWindow == 0 then
      if player.shop == 0 then
        player.shop = 1
      else
        player.shop = 0
      end
    elseif k == "l" then
      if player.skillWindow == 0 then
        player.package = 0
        player.shop = 0
        player.skillWindow = 1
      else
        player.skillWindow = 0
      end
    end
    if k == "a" or k == "d" or k == "w" or k == "s" then
      if player.doing == "" then player.doing = "walking" end
      if player.unitX == 0 and player.unitY == 0 and (player.doing == "" or player.doing == "walking") then player.dirPrev = player.dir player.lastDir = player.dir end
    end
    if k == "k" and player.keys > 0 then
      if map[2][map.width*player.y+player.x] == 3 then map[2][map.width*player.y+player.x] = 0 player.keys = player.keys - 1
      elseif map[2][map.width*player.y+player.x+2] == 3 then map[2][map.width*player.y+player.x+2] = 0 player.keys = player.keys - 1
      elseif map[2][map.width*(player.y-1)+player.x+1] == 3 then map[2][map.width*(player.y-1)+player.x+1] = 0 player.keys = player.keys - 1
      elseif map[2][map.width*(player.y+1)+player.x+1] == 3 then map[2][map.width*(player.y+1)+player.x+1] = 0 player.keys = player.keys - 1
      end
    end
    if k == "j" and player.equipment[2] ~= nil then
      player.equipment[2].durability[1] = player.equipment[2].durability[1] - 1
      bullets:new(1, player.lastDir, player.equipment[2].attack, player.x, player.y, "player")
      if player.equipment[2].durability[1] <= 0 then
        player.equipment[2] = nil
      end
    end
  elseif menu == -2 then
    editor:keypressed(k)
  end
end
function love.keyreleased(k)
  if menu == 0 then
    if (k == "a" and player.dir == "left") or (k == "d" and player.dir == "right") or (k == "w" and player.dir == "up") or (k == "s" and player.dir == "down") then
      player.dir = ""
    end
  elseif menu == -2 then
    editor:keyreleased(k)
  end
end
function player.move(dir, dt)
  if player.unitX == 0 and player.unitY == 0 then
    for i = 1, #map.monsters do
      local monster = map.monsters[i]
      local isFighting = false
      if player.x == monster.x + 1 and player.y == monster.y and player.dirPrev == "left" then
        player.dir = "left"
        player.dirPrev = player.dir
        player.doing = "fighting"
        isFighting = true
      elseif player.x == monster.x - 1 and player.y == monster.y and player.dirPrev == "right" then
        player.dir = "right"
        player.dirPrev = player.dir
        player.doing = "fighting"
        isFighting = true
      elseif player.x == monster.x and player.y == monster.y + 1 and player.dirPrev == "up" then
        player.dir = "up"
        player.dirPrev = player.dir
        player.doing = "fighting"
        isFighting = true
      elseif player.x == monster.x and player.y == monster.y - 1 and player.dirPrev == "down" then
        player.dir = "down"
        player.dirPrev = player.dir
        player.doing = "fighting"
        isFighting = true
      end
      if player.doing == "fighting" and isFighting then
        monster.timer = monster.timer + dt
        if monster.timer >= monster.timeout then
          monster.timer =  0
          local harm = player.attack
          monster.HP = monster.HP - harm
          if player.equipment[1] ~= nil then
            player.equipment[1].durability[1] = player.equipment[1].durability[1] - 1
            monster.HP = monster.HP - player.equipment[1].attack
            harm = harm + player.equipment[1].attack
            if player.equipment[1].durability[1] <= 0 then
              player.equipment[1] = nil
            end
          end
          newAnimation("minus HP", monster.x*40-player.x*40+400, monster.y*40-player.y*40+260, harm, 25, 0)
          harm = monster.attack - player.defence
          if harm < 0 then harm = 0 end
          if monster.attack > 0 and harm >= 0 then harmPlayer(harm) end
          ifMonsterDie(monster, i)
          if player.HP <= 0 then
            clean()
          end
          return
        end
      end
    end
  end
  if player.doing == "walking" or player.doing == "sliding" then
    if dir == "left" and map[1][map.width*player.y+player.x] ~= 0 and map[2][map.width*player.y+player.x] < 3 then
      player.unitX = player.unitX - 5
      if player.unitX <= -40 then
        player.unitX = 0
        player.x = player.x - 1
        nextGrid(dir)
      end
    elseif dir == "right" and map[1][map.width*player.y+player.x+2] ~= 0 and map[2][map.width*player.y+player.x+2] < 3 then
      player.unitX = player.unitX + 5
      if player.unitX >= 40 then
        player.unitX = 0
        player.x = player.x + 1
        nextGrid(dir)
      end
    elseif dir == "up" and map[1][map.width*(player.y-1)+player.x+1] ~= 0 and map[2][map.width*(player.y-1)+player.x+1] < 3 then
      player.unitY = player.unitY - 5
      if player.unitY <= -40 then
        player.unitY = 0
        player.y = player.y - 1
        nextGrid(dir)
      end
    elseif dir == "down" and map[1][map.width*(player.y+1)+player.x+1] ~= 0 and map[2][map.width*(player.y+1)+player.x+1] < 3 then
      player.unitY = player.unitY + 5
      if player.unitY >= 40 then
        player.unitY = 0
        player.y = player.y + 1
        nextGrid(dir)
      end
    end
  end
  if map[2][map.width*player.y+player.x+1] == 1 then
    map[2][map.width*player.y+player.x+1] = 0
    player.diamonds = player.diamonds + 1
    if player.diamonds == map.goals then
      clean()
      return
    end
  elseif map[2][map.width*player.y+player.x+1] == 2 then
    map[2][map.width*player.y+player.x+1] = 0
    player.keys = player.keys + 1
  end
end
function nextGrid(dir)
  local grid = {map[1][map.width*player.y+player.x+1], map[1][map.width*player.y+player.x+1]}
  if grid[1] ~= 10 or (dir == "left" and (map[1][map.width*player.y+player.x] == 0 or map[2][map.width*player.y+player.x] == 3)) or (dir == "right" and (map[1][map.width*player.y+player.x+2] == 0 or map[2][map.width*player.y+player.x+2] == 3)) or (dir == "up" and (map[1][map.width*(player.y-1)+player.x+1] == 0 or map[2][map.width*(player.y-1)+player.x+1] == 3)) or (dir == "down" and (map[1][map.width*(player.y+1)+player.x+1] == 0 or map[2][map.width*(player.y+1)+player.x+1] == 3)) then player.doing = "walking" player.dirPrev = player.dir if player.dir ~= "" then player.lastDir = player.dir end
  elseif grid[1] == 10 then player.doing = "sliding" end
end
function startGame(Map)
  map = instMap(Map)
  player.x = map.player.x
  player.y = map.player.y
end
function instMap(Map)
  local instance = {monsters = {}}
  instance.width = Map.width
  for i = 1, #Map.monsters do
    instance.monsters[i] = {timer = 0.5, timeout = 1}
    instance.monsters[i].x = Map.monsters[i].x
    instance.monsters[i].y = Map.monsters[i].y
    instance.monsters[i].HP = Map.monsters[i].maxHP
    instance.monsters[i].maxHP = Map.monsters[i].maxHP
    instance.monsters[i].attack = Map.monsters[i].attack
    instance.monsters[i].model = Map.monsters[i].model
    instance.monsters[i].reward = Map.monsters[i].reward
    for j = 1, #Map.monsters[i] do
      instance.monsters[i][j] = Map.monsters[i][j]
    end
  end
  for i = 1, #Map do
    instance[i] = {}
    for j = 1, #Map[i] do
      instance[i][j] = Map[i][j]
    end
  end
  instance.player = Map.player
  instance.goals = Map.goals
  instance.keys = Map.keys
  return instance
end
function clean()
  player.diamonds = 0
  player.keys = 0
  player.dir = ""
  player.dirPrev = ""
  player.lastDir = "down"
  player.doing = ""
  player.unitX = 0
  player.unitY = 0
  player.maxHP = 100
  player.HP = player.maxHP
  player.maxMP = 100
  player.MP = player.maxMP
  player.attack = 4
  player.defence = 0
  player.items = {}
  player.equipment = {}
  player.package = 0
  player.shop = 0
  player.skillWindow = 0
  player.slot = {position = 1,{},{},{},{},{},{}}
  player.EXP = 0
  player.level = 1
  player.money = 0
  player.skillPoint = 0
  animations = {}
  while bullets[1] ~= nil do
    table.remove(bullets, 1)
  end
  for i = 1, #player.skills do
    player.skills[i].cost = player.skills[i].originCost
    if player.skills[i].top > 1 then
      player.skills[i].level = 0
    end
  end
  drag = nil
  map = nil
  menu = 1
end
function newAnimation(Type, x, y, n, s, delay)
  animations[#animations + 1] = {Type = Type, x = x, y = y, n = n, s = s, timer = 0 - delay, delay = delay, opacity = 1}
end
function playAnimation()
  for i = 1, #animations do
    if animations[i].delay <= 0 then
      local animation = animations[i]
      local x = animation.x
      local y = animation.y
      local n = animation.n
      local s = animation.s
      if animation.Type == "minus HP" then
        love.graphics.setColor(1, 0, 0, animation.opacity)
        love.graphics.setFont(fontSize[s])
        love.graphics.printf("-"..n, x - 50, y, 140, "center")
        animation.y = animation.y - 1
        animation.opacity = animation.opacity - 0.02
        if animation.timer > 1.5 then table.remove(animations, i) playAnimation() return end
      elseif animation.Type == "restore" then
        love.graphics.setColor(0, 1, 0, animation.opacity)
        love.graphics.setFont(fontSize[s])
        love.graphics.printf("+"..n, x - 50, y, 140, "center")
        animation.y = animation.y - 1
        animation.opacity = animation.opacity - 0.02
        if animation.timer > 1 then table.remove(animations, i) playAnimation() return end
      elseif animation.Type == "plus MP" then
        love.graphics.setColor(0.24, 0.15, 1, animation.opacity)
        love.graphics.setFont(fontSize[s])
        love.graphics.printf("+"..n, x - 50, y, 140, "center")
        animation.y = animation.y - 1
        animation.opacity = animation.opacity - 0.02
        if animation.timer > 1 then table.remove(animations, i) playAnimation() return end
      elseif animation.Type == "plus EXP" then
        love.graphics.setColor(0.71, 0.32, 0.77, animation.opacity)
        love.graphics.setFont(fontSize[s])
        love.graphics.printf("+"..n, x - 50, y, 140, "center")
        animation.y = animation.y - 1
        animation.opacity = animation.opacity - 0.02
        if animation.timer > 1 then table.remove(animations, i) playAnimation() return end
      elseif animation.Type == "plus money" or animation.Type == "cost money" then
        love.graphics.setColor(1, 0.95, 0.1, animation.opacity)
        love.graphics.setFont(fontSize[s])
        if animation.Type == "plus money" then
          love.graphics.printf("+"..n, x - 50, y, 140, "center")
        elseif animation.Type == "cost money" then
          love.graphics.printf("-"..n, x - 50, y, 140, "center")
        end
        animation.y = animation.y - 1
        animation.opacity = animation.opacity - 0.02
        if animation.timer > 1 then table.remove(animations, i) playAnimation() return end
      elseif animation.Type == "item" then
        love.graphics.setColor(1, 1, 1, animation.opacity)
        love.graphics.draw(images.thing[n], x, y, 0, s)
        animation.opacity = animation.opacity - 0.02
        if animation.timer > 1.5 then table.remove(animations, i) playAnimation() return end
      end
    end
  end
end
function getItem(model)
  newAnimation("item", 400, 245, model, 1.26, 0.1)
  for i = 1, 100 do
    if player.items[i] ~= nil then
      if player.items[i].model == model then
        player.items[i].amount = player.items[i].amount + 1
        return
      end
    end
  end
  local l = 1
  for i = 1, 100 do
    if player.items[i] == nil then
      l = i
      break
    end
  end
  player.items[l] = {amount = 1, model = model, page = math.floor((l-1)/32)}
  player.items[l].x = (l - 1) % 8
  player.items[l].y = math.floor((l - 1) / 8) - player.items[l].page * 4
  function draw(self)
    if player.package == self.page + 1 then
      love.graphics.setColor(1, 1, 1)
      love.graphics.draw(images.thing[self.model], self.x*57 + 337, self.y*57 + 367, 0, 1.45)
      love.graphics.setFont(fontSize[25])
      love.graphics.printf(self.amount, self.x*57 + 340, self.y*57 + 395, 42, "center")
    end
  end
  function draw2(self)
    if player.package == self.page + 1 then
      if self.explain and explanation.items[self.model] ~= nil then
        local x = mouse.x
        local y = mouse.y
        local w = 120
        local h = 180
        if x + w >= Width then
          x = x - w
        end
        if y + h >= Height then
          y = y - h
        end
        love.graphics.setColor(0, 0, 0, 0.8)
        love.graphics.rectangle("fill", x, y, w, h)
        love.graphics.setColor(1, 1, 1)
        love.graphics.setFont(fontSize[15])
        for i = 1, #explanation.items[self.model] do
          love.graphics.printf(explanation.items[self.model][i].text, x + explanation.items[self.model][i].x, y + explanation.items[self.model][i].y, w - explanation.items[self.model][i].x, "left")
        end
      end
    end
  end
  function clicked(self, x, y, button)
    if player.package ~= self.page + 1 then return end
    function equip(model)
      local durability
      local attack
      local defence
      local HP
      local Type
      local image
      if model == 4 then
        durability = 5
        attack = 1
        Type = "sword"
      elseif model == 5 then
        durability = 15
        attack = 2
        Type = "sword"
      elseif model == 6 then
        durability = 8
        attack = 6
        Type = "sword"
      elseif model == 7 then
        durability = 8
        attack = 2
        Type = "bow"
      elseif model == 8 then
        durability = 16
        attack = 3
        Type = "bow"
      elseif model == 9 then
        durability = 6
        attack = 10
        Type = "bow"
      elseif model == 22 then
        durability = 30
        defence = 1
        HP = 40
        Type = "armor"
        image = 2
      elseif model == 23 then
        durability = 50
        defence = 1
        HP = 60
        Type = "armor"
        image = 3
      elseif model == 24 then
        durability = 40
        defence = 2
        HP = 80
        Type = "armor"
        image = 3
      elseif model == 25 then
        durability = 15
        defence = 2
        HP = 20
        Type = "shield"
      elseif model == 26 then
        durability = 25
        defence = 3
        HP = 30
        Type = "shield"
      elseif model == 27 then
        durability = 25
        defence = 1
        HP = 30
        Type = "pant"
      elseif model == 28 then
        durability = 30
        defence = 2
        HP = 50
        Type = "pant"
      elseif model == 29 then
        durability = 10
        defence = 1
        HP = 25
        Type = "helmet"
      elseif model == 30 then
        durability = 20
        defence = 2
        HP = 30
        Type = "helmet"
      elseif model == 31 then
        durability = 25
        defence = 3
        HP = 40
        Type = "helmet"
      elseif model == 32 then
        durability = 30
        defence = 1
        HP = 80
        Type = "helmet"
      elseif model == 33 then
        durability = 15
        attack = 4
        Type = "sword"
      end
      local p
      if Type == "sword" then p = 1
      elseif Type == "bow" then p = 2
      elseif Type == "shield" then p = 3
      elseif Type == "armor" then p = 4
      elseif Type == "pant" then p = 5
      elseif Type == "helmet" then p = 6
      end
      if player.equipment[p] ~= nil and player.equipment[p].model == self.model then
        player.equipment[p].durability[2] = player.equipment[p].durability[2] + durability
        player.equipment[p].durability[1] = player.equipment[p].durability[1] + durability
      else
        if player.equipment[p] ~= nil then
          if player.equipment[p].defence ~= nil then player.defence = player.defence - player.equipment[p].defence end
          if player.equipment[p].HP ~= nil then player.maxHP = player.maxHP - player.equipment[p].HP end
        end
        player.equipment[p] = {durability = {durability, durability}, attack = attack, defence = defence, HP = HP, model = model, Type = Type, image = image}
        if defence ~= nil then player.defence = player.defence + defence end
        if HP ~= nil then player.maxHP = player.maxHP + HP end
      end
    end
    if player.package > 0 and isInside(self.x*57 + 337, self.y*57 + 367, 45, 45, x, y) then
      if button == 1 then
        self.amount = self.amount - 1
        if self.model == 1 then
          player.HP = player.HP + 30
          newAnimation("restore", 400, 260, 30, 25, 0)
        elseif self.model == 2 then
          player.HP = player.HP + 50
          newAnimation("restore", 400, 260, 50, 25, 0)
        elseif self.model == 3 then
          player.HP = player.HP + 80
          newAnimation("restore", 400, 260, 80, 25, 0)
        elseif (self.model >= 4 and self.model <= 9) or (self.model >= 22 and self.model <= 33) then
          equip(self.model)
        elseif self.model == 10 then
          player.HP = player.HP + 120
          newAnimation("restore", 400, 260, 120, 25, 0)
        elseif self.model == 11 then
          player.HP = player.HP + 180
          newAnimation("restore", 400, 260, 180, 25, 0)
        elseif self.model >= 12 and self.model <= 21 then
          local n
          if self.model == 12 then
            n = math.floor(player.maxHP*4/100)
          elseif self.model == 13 then
            n = math.floor(player.maxHP*6/100)
          elseif self.model == 14 then
            n = math.floor(player.maxHP*8/100)
          elseif self.model == 15 then
            n = math.floor(player.maxHP*12/100)
          elseif self.model == 16 then
            n = math.floor(player.maxHP*18/100)
          elseif self.model == 17 then
            n = math.floor(player.maxHP*10/100)
          elseif self.model == 18 then
            n = math.floor(player.maxHP*15/100)
          elseif self.model == 19 then
            n = math.floor(player.maxHP*10/100)
          elseif self.model == 20 then
            n = math.floor(player.maxHP*25/100)
          elseif self.model == 21 then
            n = math.floor(player.maxHP*15/100)
          end
          player.HP = player.HP + n
          newAnimation("restore", 400, 260, n, 25, 0)
        elseif self.model >= 40 and self.model <= 47 then
          local n
          if self.model == 40 then
            n = math.floor(player.maxMP*6/100)
          elseif self.model == 41 then
            n = math.floor(player.maxMP*10/100)
          elseif self.model == 42 then
            n = math.floor(player.maxMP*12/100)
          elseif self.model == 43 then
            n = math.floor(player.maxMP*15/100)
          elseif self.model == 44 then
            n = math.floor(player.maxMP*25/100)
          elseif self.model == 45 then
            n = math.floor(player.maxMP*15/100)
          elseif self.model == 46 then
            n = math.floor(player.maxMP*22/100)
          elseif self.model == 47 then
            n = math.floor(player.maxMP*30/100)
          end
          player.MP = player.MP + n
          newAnimation("plus MP", 400, 260, n, 25, 0)
        elseif self.model == 34 then
          player.skillPoint = player.skillPoint + 1
        elseif self.model == 35 then
          player.MP = player.MP + 30
          newAnimation("plus MP", 400, 260, 30, 25, 0)
        elseif self.model == 36 then
          player.MP = player.MP + 50
          newAnimation("plus MP", 400, 260, 50, 25, 0)
        elseif self.model == 37 then
          player.MP = player.MP + 80
          newAnimation("plus MP", 400, 260, 80, 25, 0)
        elseif self.model == 38 then
          player.MP = player.MP + 120
          newAnimation("plus MP", 400, 260, 120, 25, 0)
        elseif self.model == 39 then
          player.MP = player.MP + 180
          newAnimation("plus MP", 400, 260, 180, 25, 0)
        end
        if player.HP > player.maxHP then player.HP = player.maxHP end
        if player.MP > player.maxMP then player.MP = player.maxMP end
        if self.amount <= 0 then
          player.items[8*self.y+self.x+1+self.page*32] = nil
        end
      elseif button == 2 then
        
      end
    end
  end
  function mouseCover(self, x, y, dx, dy)
    if player.package > 0 and isInside(self.x*57 + 337, self.y*57 + 367, 45, 45, x, y) then
      self.explain = true
    elseif self.explain ~= nil then
      self.explain = nil
    end
  end
  player.items[l].draw = draw
  player.items[l].draw2 = draw2
  player.items[l].clicked = clicked
  player.items[l].mouseCover = mouseCover
end
function bullets:update()
  for i = 1, #self do
    local bullet = self[i]
    if bullet.dir == "left" then
      bullet.unitX = bullet.unitX - 4
      if bullet.unitX <= -40 then
        bullet.unitX = 0
        bullet.x = bullet.x - 1
      end
    elseif bullet.dir == "right" then
      bullet.unitX = bullet.unitX + 4
      if bullet.unitX >= 40 then
        bullet.unitX = 0
        bullet.x = bullet.x + 1
      end
    elseif bullet.dir == "up" then
      bullet.unitY = bullet.unitY - 4
      if bullet.unitY <= -40 then
        bullet.unitY = 0
        bullet.y = bullet.y - 1
      end
    elseif bullet.dir == "down" then
      bullet.unitY = bullet.unitY + 4
      if bullet.unitY >= 40 then
        bullet.unitY = 0
        bullet.y = bullet.y + 1
      end
    end
    local grid = bullet.y*map.width+bullet.x+1
    if map[2][grid] >= 3 then
      table.remove(bullets, i)
      bullets:update()
      return
    else
      if bullet.belong == "player" then
        for j = 1, #map.monsters do
          local monster = map.monsters[j]
          local skip = false
          for k = 1, #bullet.harmed do
            if bullet.harmed[k] == j then skip = true end
          end
          if bullet.x == monster.x and bullet.y == monster.y and skip == false and monster.model ~= 2 then
            monster.HP = monster.HP - bullet.attack
            newAnimation("minus HP", monster.x*40-player.x*40+400, monster.y*40-player.y*40+260, bullet.attack, 25, 0)
            ifMonsterDie(monster, j)
            if bullet.model == 1 or bullet.model == 2 then
              table.remove(bullets, i)
              bullets:update()
              return
            end
            if monster.HP <= 0 then
              bullets:update()
              return
            end
            bullet.harmed[#bullet.harmed + 1] = j
          end
        end
      end
    end
  end
end
function bullets:new(model, dir, attack, x, y, belong)
  love.audio.play(sounds[2])
  local bullet = {model = model, dir = dir, attack = attack, x = x, y = y, unitX = 0, unitY = 0, belong = belong, harmed = {}}
  bullets[#bullets + 1] = bullet
end
function bullets:draw()
  for i = 1, #self do
    local bullet = self[i]
    love.graphics.setColor(1, 1, 1)
    for y = player.y - 7, player.y + 7 do
      for x = player.x - 10, player.x + 10 do
        local grid = {map[1][map.width*y+x+1], map[2][map.width*y+x+1]}
        if grid[1] ~= nil and x >= 0 and x < map.width then
          local screenY = (y-(player.y-7))*40 - player.unitY
          local screenX = (x-(player.x-10))*40 - player.unitX
          if bullet.x == x and bullet.y == y then
            if bullet.dir == "left" then
              love.graphics.draw(images.bullet[bullet.model].left, screenX + bullet.unitX, screenY + bullet.unitY, 0, 0.63)
            elseif bullet.dir == "right" then
              love.graphics.draw(images.bullet[bullet.model].right, screenX + bullet.unitX, screenY + bullet.unitY, 0, 0.63)
            elseif bullet.dir == "up" then
              love.graphics.draw(images.bullet[bullet.model].up, screenX + bullet.unitX, screenY + bullet.unitY, 0, 0.63)
            elseif bullet.dir == "down" then
              love.graphics.draw(images.bullet[bullet.model].down, screenX + bullet.unitX, screenY + bullet.unitY, 0, 0.63)
            end
          end
        end
      end
    end
  end
end
function ifMonsterDie(monster, i)
  if monster.HP <= 0 then
    if player.doing == "fighting" then
      player.doing = ""
      player.dirPrev = player.dir
    end
    if monster.reward ~= nil then
      if monster.reward.EXP ~= nil then
        player.EXP = player.EXP + monster.reward.EXP
        newAnimation("plus EXP", 400, 260, monster.reward.EXP, 25, 0.4)
        if player.level < #player.levels and player.EXP >= player.levels[player.level + 1] then
          player.EXP = player.EXP - player.levels[player.level + 1]
          player.level = player.level + 1
          player.skillPoint = player.skillPoint + 3
          --[[--if player.level == 2 then
            player.HP = player.HP + 20
            player.maxHP = player.maxHP + 20
            player.attack = player.attack + 1
          elseif player.level == 3 then
            player.HP = player.HP + 30
            player.maxHP = player.maxHP + 30
            player.attack = player.attack + 1
          elseif player.level == 4 then
            player.HP = player.HP + 30
            player.maxHP = player.maxHP + 30
            player.attack = player.attack + 1
          elseif player.level == 5 then
            player.HP = player.HP + 40
            player.maxHP = player.maxHP + 40
            player.attack = player.attack + 2
          elseif player.level == 6 then
            player.HP = player.HP + 40
            player.maxHP = player.maxHP + 40
            player.attack = player.attack + 2
          elseif player.level == 7 then
            player.HP = player.HP + 40
            player.maxHP = player.maxHP + 40
            player.attack = player.attack + 2
          elseif player.level == 8 then
            player.HP = player.HP + 50
            player.maxHP = player.maxHP + 50
            player.attack = player.attack + 2
          end
          --]]--
        end
      end
      if monster.reward.money ~= nil then
        local n = love.math.random(monster.reward.money[2] - monster.reward.money[1] + 1) + monster.reward.money[1] - 1
        player.money = player.money + n
        newAnimation("plus money", 400, 260, n, 25, 0.8)
      end
    end
    local p = love.math.random(100)
    if monster.model == 1 then
      if p <= 1 then
        getItem(2)
      elseif p <= 2 then
        getItem(1)
      elseif p <= 6 then
        getItem(35)
      elseif p <= 26 then
        getItem(4)
      elseif p <= 56 then
        getItem(12)
      elseif p <= 60 then
        getItem(13)
      elseif p <= 72 then
        getItem(29)
      elseif p <= 80 then
        getItem(40)
      end
    elseif monster.model == 2 then
      if monster[1] == 0 then
        monster[1] = 1
      end
      getItem(monster[1])
      map[2][monster.y*map.width+monster.x+1] = 8
    elseif monster.model == 3 then
      if p <= 1 then
        getItem(3)
      elseif p <= 2 then
        getItem(2)
      elseif p <= 3 then
        getItem(36)
      elseif p <= 5 then
        getItem(1)
      elseif p <= 9 then
        getItem(5)
      elseif p <= 10 then
        getItem(20)
      elseif p <= 14 then
        getItem(21)
      elseif p <= 15 then
        getItem(18)
      elseif p <= 17 then
        getItem(16)
      elseif p <= 20 then
        getItem(15)
      elseif p <= 24 then
        getItem(17)
      elseif p <= 30 then
        getItem(14)
      elseif p <= 38 then
        getItem(13)
      elseif p <= 42 then
        getItem(22)
      elseif p <= 52 then
        getItem(29)
      elseif p <= 54 then
        getItem(25)
      elseif p <= 56 then
        getItem(27)
      elseif p <= 57 then
        getItem(30)
      elseif p <= 60 then
        getItem(35)
      elseif p <= 75 then
        getItem(40)
      elseif p <= 78 then
        getItem(41)
      elseif p <= 80 then
        getItem(45)
      elseif p <= 81 then
        getItem(46)
      end
    elseif monster.model == 4 then
      if p <= 1 then
        getItem(3)
      elseif p <= 2 then
        getItem(37)
      elseif p <= 7 then
        getItem(2)
      elseif p <= 13 then
        getItem(6)
      elseif p <= 15 then
        getItem(20)
      elseif p <= 18 then
        getItem(18)
      elseif p <= 21 then
        getItem(17)
      elseif p <= 23 then
        getItem(16)
      elseif p <= 28 then
        getItem(14)
      elseif p <= 31 then
        getItem(23)
      elseif p <= 34 then
        getItem(27)
      elseif p <= 35 then
        getItem(28)
      elseif p <= 37 then
        getItem(35)
      elseif p <= 42 then
        getItem(36)
      elseif p <= 43 then
        getItem(44)
      elseif p <= 45 then
        getItem(43)
      elseif p <= 48 then
        getItem(41)
      elseif p <= 60 then
        getItem(40)
      end
    elseif monster.model == 5 then
      if p <= 1 then
        getItem(3)
      elseif p <= 3 then
        getItem(2)
      elseif p <= 10 then
        getItem(1)
      elseif p <= 13 then
        getItem(7)
      elseif p <= 25 then
        getItem(19)
      elseif p <= 26 then
        getItem(26)
      elseif p <= 27 then
        getItem(25)
      elseif p <= 30 then
        getItem(36)
      elseif p <= 37 then
        getItem(35)
      elseif p <= 40 then
        getItem(45)
      elseif p <= 50 then
        getItem(42)
      end
    elseif monster.model == 6 then
      if p <= 1 then
        getItem(38)
      elseif p <= 2 then
        getItem(3)
      elseif p <= 3 then
        getItem(2)
      elseif p <= 10 then
        getItem(1)
      elseif p <= 22 then
        getItem(19)
      elseif p <= 23 then
        getItem(20)
      elseif p <= 27 then
        getItem(9)
      elseif p <= 28 then
        getItem(8)
      elseif p <= 29 then
        getItem(24)
      elseif p <= 30 then
        getItem(32)
      elseif p <= 33 then
        getItem(36)
      elseif p <= 43 then
        getItem(42)
      elseif p <= 44 then
        getItem(44)
      elseif p <= 48 then
        getItem(43)
      end
    elseif monster.model == 7 then
      if p <= 1 then
        getItem(47)
      elseif p <= 3 then
        getItem(2)
      elseif p <= 10 then
        getItem(1)
      elseif p <= 15 then
        getItem(5)
      elseif p <= 25 then
        getItem(14)
      elseif p <= 28 then
        getItem(15)
      elseif p <= 30 then
        getItem(16)
      elseif p <= 33 then
        getItem(25)
      elseif p <= 34 then
        getItem(31)
      elseif p <= 39 then
        getItem(32)
      elseif p <= 42 then
        getItem(22)
      elseif p <= 44 then
        getItem(20)
      elseif p <= 45 then
        getItem(46)
      elseif p <= 46 then
        getItem(45)
      elseif p <= 48 then
        getItem(42)
      elseif p <= 49 then
        getItem(36)
      elseif p <= 54 then
        getItem(35)
      end
    elseif monster.model == 8 then
      if p <= 1 then
        getItem(10)
      elseif p <= 2 then
        getItem(3)
      elseif p <= 5 then
        getItem(2)
      elseif p <= 10 then
        getItem(1)
      elseif p <= 16 then
        getItem(6)
      elseif p <= 19 then
        getItem(20)
      elseif p <= 23 then
        getItem(16)
      elseif p <= 27 then
        getItem(18)
      elseif p <= 34 then
        getItem(15)
      elseif p <= 35 then
        getItem(31)
      elseif p <= 36 then
        getItem(26)
      elseif p <= 40 then
        getItem(30)
      elseif p <= 43 then
        getItem(8)
      elseif p <= 46 then
        getItem(33)
      elseif p <= 47 then
        getItem(37)
      elseif p <= 50 then
        getItem(36)
      elseif p <= 60 then
        getItem(35)
      elseif p <= 65 then
        getItem(41)
      elseif p <= 70 then
        getItem(40)
      end
    elseif monster.model == 9 then
      if p <= 1 then
        getItem(47)
      elseif p <= 2 then
        getItem(3)
      elseif p <= 5 then
        getItem(2)
      elseif p <= 10 then
        getItem(1)
      elseif p <= 16 then
        getItem(33)
      elseif p <= 18 then
        getItem(26)
      elseif p <= 20 then
        getItem(31)
      elseif p <= 21 then
        getItem(24)
      elseif p <= 23 then
        getItem(28)
      elseif p <= 25 then
        getItem(25)
      elseif p <= 27 then
        getItem(23)
      elseif p <= 30 then
        getItem(20)
      elseif p <= 38 then
        getItem(21)
      elseif p <= 40 then
        getItem(16)
      elseif p <= 43 then
        getItem(8)
      elseif p <= 44 then
        getItem(46)
      elseif p <= 46 then
        getItem(45)
      elseif p <= 47 then
        getItem(37)
      elseif p <= 50 then
        getItem(36)
      elseif p <= 58 then
        getItem(35)
      end
    end
    table.remove(map.monsters, i)
  end
end
function harmPlayer(n)
  player.HP = player.HP - n
  newAnimation("minus HP", 400, 260, n, 25, 0)
  for i = 3, 6 do
    local equip = player.equipment[i]
    if equip ~= nil then
      equip.durability[1] = equip.durability[1] - 1
      if equip.durability[1] <= 0 then
        player.defence = player.defence - equip.defence
        if equip.HP ~= nil then
          player.maxHP = player.maxHP - equip.HP
          if player.HP > player.maxHP then player.HP = player.maxHP end
        end
        player.equipment[i] = nil
      end
    end
  end
end
function slotClicked(self, x, y, button)
  if button == 1 and player.MP >= self.skill.MP then
    if self.skill.image == 5 then
      player.MP = player.MP - self.skill.MP
      if self.skill.level == 1 then
        bullets:new(2, player.lastDir, 3, player.x, player.y, "player")
      elseif self.skill.level == 2 then
        bullets:new(2, player.lastDir, 6, player.x, player.y, "player")
      elseif self.skill.level == 3 then
        bullets:new(2, player.lastDir, 10, player.x, player.y, "player")
      end
    elseif self.skill.image == 6 then
      player.MP = player.MP - self.skill.MP
      if self.skill.level == 1 then
        bullets:new(3, player.lastDir, 2, player.x, player.y, "player")
      elseif self.skill.level == 2 then
        bullets:new(3, player.lastDir, 4, player.x, player.y, "player")
      elseif self.skill.level == 3 then
        bullets:new(3, player.lastDir, 7, player.x, player.y, "player")
      end
    end
  elseif button == 2 then
    player.slot[player.slot.position][self.position] = nil
    return
  end
end